; 
    include \masm32\include\masm32rt.inc
    .686
    include counter2.asm

    PRIORITY_CLASS equ HIGH_PRIORITY_CLASS
    ;REALTIME_PRIORITY_CLASS

    TEST_SETS     EQU 5
    REPEAT_COUNT  EQU 20
    SAMPLE_COUNT  EQU 16

; 

    ; -------------------------------------------------------
    ; This is an assembly-time random number generator based
    ; on code by George Marsaglia:
    ;   #define znew  ((z=36969*(z&65535)+(z>>16))<<16)
    ;   #define wnew  ((w=18000*(w&65535)+(w>>16))&65535)
    ;   #define MWC   (znew+wnew)
    ; -------------------------------------------------------

    @seed MACRO
      @znew_seed@ = 362436069
      @wnew_seed@ = 521288629
    ENDM

    @seed

    @rnd MACRO base:REQ
      LOCAL znew, wnew

      @znew_seed@ = 36969 * (@znew_seed@ AND 65535) + (@znew_seed@ SHR 16)
      znew = @znew_seed@ SHL 16

      @wnew_seed@ = 18000 * (@wnew_seed@ AND 65535) + (@wnew_seed@ SHR 16)
      wnew = @wnew_seed@ AND 65535

      EXITM <(znew + wnew) MOD base>
    ENDM

; 

    abs MACRO op
        add op, 0
        jns @F
        neg op
      @@:
    ENDM

; 
    .data
      m32 dd 0
      m16 dw 0
      m8  db 0
    .code
; 
start:
; 
    FOR num,<0,1,2147483647,-1,-2147483648>
      mov eax, num
      abs eax
      print ustr$(eax),9
    ENDM
    print chr$(13,10)
    FOR num,<0,1,2147483647,-1,-2147483648>
      mov m32, num
      abs m32
      print ustr$(m32),9
    ENDM
    print chr$(13,10)

    FOR num,<0,1,32767,-1,-32768>
      mov ax, num
      abs ax
      movzx eax, ax
      print ustr$(eax),9
    ENDM
    print chr$(13,10)
    FOR num,<0,1,32767,-1,-32768>
      mov m16, num
      abs m16
      movzx eax, m16
      print ustr$(eax),9
    ENDM
    print chr$(13,10)

    FOR num,<0,1,127,-1,-128>
      mov al, num
      abs al
      movzx eax, al
      print ustr$(eax),9
    ENDM
    print chr$(13,10)
    FOR num,<0,1,127,-1,-128>
      mov m8, num
      abs m8
      movzx eax, m8
      print ustr$(eax),9
    ENDM
    print chr$(13,10,13,10)

    invoke Sleep, 4000

    REPEAT TEST_SETS

      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs eax
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs eax",13,10

      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov m32, @rnd(0ffffffffh)
            abs m32
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs m32",13,10

      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs ax
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs ax",13,10

      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov m32, @rnd(0ffffffffh)
            abs WORD PTR m32
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs m16",13,10

      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov eax, @rnd(0ffffffffh)
            abs al
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs al",13,10

      xor ebx, ebx
      REPEAT SAMPLE_COUNT
        @seed
        ctr_begin 1000, PRIORITY_CLASS
          REPEAT REPEAT_COUNT
            mov m32, @rnd(0ffffffffh)
            abs BYTE PTR m32
          ENDM
        ctr_end
        add ebx, eax
      ENDM
      mov ecx, SAMPLE_COUNT
      mov eax, ebx
      div ecx
      print ustr$(eax), " cycles, abs m8",13,10,13,10
    ENDM

    inkey "Press any key to exit..."
    exit
; 
end start
